/*
	decode mime header (for Japanese)

	(usage)
		char	*decode_mime(char *dest, char *src)

	(arguments)
		dest ... pointer to destination buffer
		src  ... pointer to source buffer

	(return value)
		pointer to destination buffer (same to "dest")

	this source is 'not free' and 'not guaranteed'
	10, Jan, 2000 Rick

	based on

**	libisa.a
**	decode_mimeB.c copyright (c) 1998/ 2/24(Tue) 21:47:26 by isako.
**	$Id: decode_mimeB.c,v 1.2 1998-11-22 20:26:06+0900 isaki Exp $
*/

#include	<string.h>
#include	"mail.h"

char	JIS_HEADER[]="ISO-2022-JP";
char	EUC_HEADER[]="EUC-JP";
char	SJIS_HEADER[]="SHIFT_JIS";
char	CHARSET_HEADER[]="CHARSET=";

static int
chk_decode(m)
MIMEMACHINE	*m;
{
	char	*p;

	if (headicmp(m->bs, JIS_HEADER)) {
		/* "ISO-2022-JP" */
		m->bs += sizeof(JIS_HEADER) - 1;
		m->converter = jis2sjis;
	} else if (headicmp(m->bs, EUC_HEADER)) {
		/* "EUC-JP" */
		m->bs += sizeof(EUC_HEADER) - 1;
		m->converter = euc2sjis;
	} else if (headicmp(m->bs, SJIS_HEADER)) {
		/* "Shift-JIS" */
		m->bs += sizeof(SJIS_HEADER) - 1;
	} else {
		return FALSE;
	}

	if (p = strstr(m->bs, "?B?")) {
		/* MIME"B" fR[h */
		m->decoder = decbenc;
	} else if (p = strstr(m->bs, "?Q?")) {
		/* MIME"Q" fR[h */
		m->decoder = decqenc;
	} else {
		return FALSE;
	}
	m->bs = p + 3;

	/* Ȍ "?=" 邩 */
	m->be = strstr(m->bs, "?=");
	return (int)(m->be);
}

static int
do_decode(d, m)
char	*d;
MIMEMACHINE	*m;
{
	int	i = -1;

	if (m->decoder) {
		*m->be = '\0';
		i = m->decoder(d, m->bs);
		if (i > 0 && m->converter) {
			m->converter(d, d);
			i = strlen(d);
		}
		*m->be = '?';
	}
	return i;
}

char
*decode_mime(char *dest, char *src)
{
	char	*d;
	char	*s;
	int	i;
	MIMEMACHINE	m;

	for (s = src, d = dest; *s;) {
		if (s[0] == '=' && s[1] == '?') {
			m.bs = s + 2;
			m.decoder = NULL;
			m.converter = NULL;
			if (chk_decode(&m)) {
				i = do_decode(d, &m);
				if (i > 0) {
					/* fR[hłΈʒuC */
					d += i;
					s = m.be + 2;
					continue;
				}
			}
			/* fR[hoȂꍇ *d++=*s++; ֐i */
		}
		*d++ = *s++;
	}

	*d = '\0';
	return dest;
}
